@echo off

REM Check if environment properly setup
CALL INIT.BAT
IF DEFINED ERROR_INSTALL GOTO end

if not exist "%BACKUP_DIR%" goto post_action
FOR %%F in ("%INSTALLED_PATH%"\*) DO if not exist "%BACKUP_DIR%\%%~nF%%~xF" echo unable to restore "%%~nF%%~xF"
FOR %%F in ("%INSTALLED_PATH%"\*) DO if exist "%BACKUP_DIR%\%%~nF%%~xF"  copy /Y "%BACKUP_DIR%\%%~nF%%~xF" "%INSTALL_PATH%"

if DEFINED GAC_NOT_FOUND GOTO post_action
REM Check if the files installed are in the GAC
FOR %%F in ("%INSTALLED_PATH%"\*) DO if exist "%BACKUP_DIR%\%%~nF%%~xF"  CALL :GAC_UNINSTALL "%BACKUP_DIR%\%%~nF%%~xF"

:post_action
echo restoration completed...
GOTO END
:end
GOTO :EOF

REM Function to install a file in the GAC if present 
:gac_uninstall
FOR /F "usebackq" %%c IN (`gacutil -l %~n1 ^| find "= 1" /c`) do set installed=%%c
if "%installed%" == "0" goto :EOF
REM Replace file in the GAC
gacutil /if %1
GOTO :EOF